/*
*************************************************************************************************
*****																							*
*****							T A S T A T U R A B F R A G E									*
*****																							*
*****							07.2005 - 07.2005  Thilo Mlls									*
*****																							*
*****	Abfrage einer 4x4 - Matrix - Tastatur, belegt einen Port								*
*****		 																					*
*****		 																					*
*****	_______________________________________________________________________________________	*
*****	Quellcode fr GNU-C-Compiler (AVR-GCC)													*
*************************************************************************************************
*/

//#include <avr/delay.h>					// wenn schon eingebunden, hier lschen

//volatile unsigned char T_Byte = 0;


/***************************************************************************************/
/*** Start Tastaturabfrage *************************************************************/
/***************************************************************************************/

char _scan_key (char Null)
{

volatile unsigned char Ergebnis;
volatile unsigned char T_Byte;
/***************************************************************************************/
// Initialisierung
/***************************************************************************************/
	
// Datenrichtung der Ports	
	
	DDRA = 0b11110000;				// Port fr die Tastatur muss evtl. angepasst werden
	PORTA = 0b00001111;

/***************************************************************************************/
// Beginn Subroutinen
/***************************************************************************************/
/***************************************************************************************/

/***************************************************************************************/
/***************************************************************************************/
/***************************************************************************************/
/***************************************************************************************/
// Beginn Programmablauf

/***************************************************************************************/
T_Byte = ' ';

if (PINA != 15)								// nur bei gedrckter Taste abfragen
	{	
		PORTA = 0b00001111;						// Spalten abfragen
		_delay_us(1);
		Ergebnis = PINA;
		
		DDRA = 0b00001111;						
		PORTA = 0b11110000;
		
		PORTA = 0b11110000;						// Zeilen abfragen
		_delay_us(1);
		Ergebnis += PINA;						// Zeilen und Spalten verknpfen
		
		DDRA = 0b11110000;
		PORTA = 0b00001111;						// Port-Ausgangszustand wiederherstellen
		
		switch (Ergebnis)
			{
			case 119: T_Byte = '0'; break;		// Bitmuster auswerten und Byte zuweisen
			case 123: T_Byte = '.'; break;
			case 125: T_Byte = '-'; break;
			case 126: T_Byte = 'E'; break;
			case 183: T_Byte = '1'; break;
			case 187: T_Byte = '2'; break;
			case 189: T_Byte = '3'; break;
			case 190: T_Byte = 'C'; break;
			case 215: T_Byte = '4'; break;
			case 219: T_Byte = '5'; break;
			case 221: T_Byte = '6'; break;
			case 222: T_Byte = 'D'; break;
			case 231: T_Byte = '7'; break;
			case 235: T_Byte = '8'; break;
			case 237: T_Byte = '9'; break;
			case 238: T_Byte = 'F'; break;
			default : T_Byte = ' '; break;
			}
		
		for(unsigned char i=0;i<15;i++)            		// Pause 15 x 10ms = 150ms (entprellung)
			{
				_delay_ms(160);										// 255ms/16MHz=16ms
			}
	}

	
/***************************************************************************************/	
/***************************************************************************************/
/*** Ende Tastaturabfrage **************************************************************/
/***************************************************************************************/
return T_Byte;		// Routine verlassen und Byte bergeben
}


